(* ------------------------------------------------------ *)
(*                     KEYS.PAS                           *)
(*            Abfrage des Keyboard-Status                 *)
(*         (c) 1990 Frederick Knauf & TOOLBOX             *)
(* ------------------------------------------------------ *)
UNIT Keys;                    { txKeys }

INTERFACE

CONST
  INS         = 128;
  CAPS_LOCK   =  64;
  NUM_LOCK    =  32;
  SCROLL_LOCK =  16;
  ALT         =   8;
  CTRL        =   4;
  LEFT_SHIFT  =   2;
  RIGHT_SHIFT =   1;

  LESEN       =   1;
  SETZEN      =   2;
  LOESCHEN    =   3;

  FUNCTION Status(K, B : BYTE) : BOOLEAN;

IMPLEMENTATION

  FUNCTION Status;
  VAR
    KStat : BYTE ABSOLUTE $0000:$0417;
  BEGIN
    Status := TRUE;
    CASE B OF
      LESEN    : IF (k AND KStat) <> k THEN
                   Status := FALSE;
      SETZEN   : KStat := KStat OR k;
      LOESCHEN : KStat := KStat AND (255 - k);
    END;
  END;

BEGIN
END.
(* ------------------------------------------------------ *)
(*                   Ende von KEYS.PAS                    *)
